#ifndef SHAPE_H
#define SHAPE_H

#include <vector>

class Vector2f;

class Vertex;
class Normal;

class Arrow {
public:
  /*! Parameter-less constructor
   */
  Arrow();

  /*!
   */
  void set_size(float arrow_width, float arrow_length)
  { m_arrow_width = arrow_width; m_arrow_length = arrow_length; }

  /*! \todo change to set_width
   */
  float get_arrow_length() const { return m_arrow_length; }
  float get_arrow_width() const { return m_arrow_width; } 
 
  /*! \todo change to set_lebgth
   */
  void set_arrow_length(float length) { m_arrow_length = length; }
  void set_arrow_width(float width) { m_arrow_width = width; }

  /*!
   */
  void draw_arrow(const Vector2f & pos, const Vector2f & dir,
                  bool fill = true) const;

protected:
  /*! Constructor
   */
  Arrow(float arrow_length, float arrow_width);

  /*! Copy constructor
   */
  Arrow(const Arrow & arrow);
  
  /*! Assignment operator
   */
  Arrow & operator=(const Arrow & arrow);

  float m_arrow_length;         // measured in pixels
  float m_arrow_width;          // measured in pixels
};

#endif
