#if (defined _MSC_VER)
#include <windows.h>
#endif
#include <GL/gl.h>
#include <math.h>

#include "Circle.h"
#include "Vector2f.h"

#define PI (4*(float)atan(1))

/*!
 */
void Circle::draw(const Vector2f & center, float radius)
{
#if 0
  glPointSize(radius * 2.0f);
  glPointSize(10.0f);
  glEnable(GL_POINT_SMOOTH);
  glBegin(GL_POINTS);
  glVertex2fv(center);
  glEnd();
#else
  glBegin(GL_POLYGON);
  int num_points = (int) radius;
  if (num_points < 6) num_points = 6;
  float angle = PI * 2.0f / num_points;
  for (int i = 0; i <= num_points; i++) {
    float x = center[0] + radius * cosf(angle * i);
    float y = center[1] - radius * sinf(angle * i);
    glVertex2f(x, y);
  }
  glEnd();
#endif
}
