#ifndef DIAGRAM_SIM_H
#define DIAGRAM_SIM_H

#include "Agent.h"
#include "Diagram.h"
#include "Reshape_viewport_events.h"

class Highlight_normals_event;
class Mode_event;
class Simulate_event;
class Collision_test_event;
class Translate_event;
class Rotate_event;

class Diagram_sim : public Agent, public Diagram {
private:
  float m_arrow_length;         // measured in pixels
  float m_arrow_width;          // measured in pixels
  float m_gap;
  
public:
  virtual void identify(void);

  /*!
   */
  virtual void handle(Reshape_ds_viewport_event * reshape_event);

  /*!
   */
  virtual void handle(Highlight_normals_event * event);

  /*!
   */
  virtual void handle(Mode_event * event);

  /*!
   */
  virtual void handle(Simulate_event * event);
  
  void handle(Collision_test_event * event);
  void handle(Translate_event * event);
  void handle(Rotate_event * event);

  /*!
   */
  Diagram_sim(void);

  /*!
   */
  virtual ~Diagram_sim(void);

  /*!
   */
  void init();
};

#endif
