#ifndef DIAGRAM_SPACE_H
#define DIAGRAM_SPACE_H

#include "Diagram_sim.h"
#include "Viewport.h"
#include "Frustum.h"
#include "Reshape_viewport_events.h"

class Trans_poly;

class Diagram_space : public Agent {
private:
  Diagram_sim m_diagram_sim;
  Viewport m_viewport;
  Frustum m_frustum;

  float m_near;
  float m_far;

  bool m_reshaped;

public:
  /*!
   */
  Diagram_space(void);

  /*!
   */
  virtual ~Diagram_space(void);
  
  /*!
   */
  void set_robot(Trans_poly & robot);

  /*!
   */
  void set_obstacle(Trans_poly & obstacle);
  
  /*!
   */
  void init(void);
  
  /*!
   */
  void draw(void);

  /*!
   */
  void set_viewport(int vp_left, int vp_bottom, int vp_width, int vp_height);

  /*!
   */
  virtual void identify(void);

  /*!
   */
  virtual void handle(Reshape_ds_viewport_event * reshape_event);
};

#endif
