#include "Math.h"



bMath math;



unsigned char Math::m_iSqrt[TABLE_SIZE];



union _flint {

  unsigned long    i;

  float            f;

} _fi, _fo;



void Math::make_inverse_sqrt_lookup_table(void)

{

  register long f;

  register unsigned char * h;

  union _flint fi, fo;



  h = m_iSqrt;

  for (f = 0, h = m_iSqrt; f < TABLE_SIZE; f++) {

    fi.i = ((EXP_BIAS-1) << EXP_POS) | (f << LOOKUP_POS);

    fo.f = (float) (1.0 / sqrt(fi.f));

    *h++ = (unsigned char)

      (((fo.i + (1<<(SEED_POS-2))) >> SEED_POS) & 0xFF); /* rounding */

  }

  m_iSqrt[TABLE_SIZE / 2] = 0xFF;    /* Special case for 1.0 */

}



// Returns the inverse square root:

float Math::sqrt_reciprocalf(float x)

{

  unsigned long a = ((union _flint*)(&x))->i;

  float arg = x;

  union _flint seed;

  float r;



  seed.i = SET_EXP(((3*EXP_BIAS-1) - GET_EXP(a)) >> 1)

    | SET_MANTSEED(m_iSqrt[GET_EMANT(a)]);



  /* Seed: accurate to LOOKUP_BITS */

  r = seed.f;



  /* First iteration: accurate to 2*LOOKUP_BITS */

  r = (float) ((3.0 - r * r * arg) * r * 0.5);



#if 0  /* Wow!  We don't need this much precision! */

  /* Second iteration: accurate to 4*LOOKUP_BITS */

  r = (float) ((3.0 - r * r * arg) * r * 0.5);

#endif



  return r;

}

