#ifndef NORMAL_DIAGRAM_SCENE_H
#define NORMAL_DIAGRAM_SCENE_H

#include "Scene.h"
#include "Diagram_space.h"
#include "Work_space.h"
#include "Conf_space.h"
#include "Aux_space.h"
#include "Viewport.h"
#include "Frustum.h"

class Tick_event;

class Normal_diagram_scene : public Scene {
public:
  /*!
   */
  Normal_diagram_scene();

  /*!
   */
  virtual ~Normal_diagram_scene();

  /*!
   */
  static void set_verbose_level(int verbose_level)
  { s_verbose_level = verbose_level; }
  
  virtual void init(void);
  virtual void handle(Tick_event * tick_event);
  virtual void draw(void);
  virtual void reshape(GLint width, GLint height);
  virtual void keyboard(unsigned char c, int x, int y);

  /*!
   */
  virtual void identify(void);
  
private:
  static int s_verbose_level;

  bool m_simulate;
  Mode m_mode;
  
  Work_space m_work_space;
  Aux_space m_auxiliary_space;
  Conf_space m_conf_space;
  Diagram_space m_diagram_space;

  Viewport m_viewport;
  Frustum m_frustum;

  int m_win_width;
  int m_win_height;

  float m_near;
  float m_far;

  float m_line_width;

  void draw_separators(void);
};

#endif
