#include <string>
#if (defined _MSC_VER)
#include "my_getopt.h"
#else
#include <stdlib.h>
#include <getopt.h>
#endif
#include "Parse_command_line.h"

int Parse_command_line::s_argc = 0;
char ** Parse_command_line::s_argv = 0;
const char * Parse_command_line::s_prog_name;
std::set<Parse_command_line *> Parse_command_line::s_set;

#if 0
#if defined(__GNUC__)
int getsubopt(char ** optionsp,  const char * tokens[], char ** valuep)
{
	register char *s = *optionsp, *p;
	register int i;
	size_t optlen;

	*valuep = NULL;
	if (*s == '\0')
		return (-1);
	p = strchr(s, ',');		/* find next option */
	if (p == NULL) {
		p = s + strlen(s);
	} else {
		*p++ = '\0';		/* mark end and point to next */
	}
	*optionsp = p;			/* point to next option */
	p = strchr(s, '=');		/* find value */
	if (p == NULL) {
		optlen =  strlen(s);
		*valuep = NULL;
	} else {
		optlen = p - s;
		*valuep = ++p;
	}
	for (i = 0; tokens[i] != NULL; i++) {
		if ((optlen == strlen(tokens[i])) &&
		    (strncmp(s, tokens[i], optlen) == 0))
			return (i);
	}
	/* no match, point value at option and return error */
	*valuep = s;
	return (-1);
}
#endif
#endif

/*!
 */
Parse_command_line::Parse_command_line(int argc, char * argv[]) : m_done(false)
{
  s_argc = argc;
  s_argv = argv;
  s_prog_name = strrchr(argv[0], '\\');
  s_prog_name = (s_prog_name) ? s_prog_name+1 : argv[0];
}

/*!
 */
Parse_command_line::Parse_command_line(void) : m_done(false)
{
}

/*!
 */
void Parse_command_line::doregister(Parse_command_line * cl)
{
  s_set.insert(cl);
}

/*!
 */
bool Parse_command_line::is_valid(void) const
{
  std::string str;
  std::set<Parse_command_line *>::const_iterator it;
  for (it = s_set.begin(); it != s_set.end(); it++) {
    str += (*it)->get_option_str();
  }

  // std::cout << "Parse_command_line::is_valid: "
  //           << "options: " << str.c_str() << std::endl;
  
  optind = 1;
  int c;
  while ((c = getopt(s_argc, s_argv, str.c_str())) != EOF) {
    switch (c) {
     case '?':
      std::cerr << s_prog_name << ": invalid option -- "
                << (char) optopt << std::endl;
      std::cerr << "Try `" << s_prog_name << " -h' for more information."
                << std::endl;
      return false;
    }
  }
  return true;
}
