#ifndef PARSE_COMMAND_LINE_H
#define PARSE_COMMAND_LINE_H

#include <iostream>
#include <set>
#include "Dir_search.h"

#if 0
#if defined(__GNUC__)
int getsubopt(char ** optionsp,  const char * tokens[], char ** valuep);
#endif
#endif

/*!
 */
class Parse_command_line {
public:
  /*!
   */
  Parse_command_line(int argc, char * argv[]);

  /*!
   */
  Parse_command_line(void);

  /*!
   */
  virtual ~Parse_command_line(void) {}
  
  /*!
   */
  virtual void print_help(void) {}

  /*!
   */
  virtual char * get_option_str(void) const = 0;
  
  /*!
   */
  virtual int operator()(void) = 0;

  /*!
   */
  const char * get_prog_name(void) const { return s_prog_name; }

  /*!
   */
  void doregister(Parse_command_line * cl);

  /*!
   */
  bool is_valid(void) const;
  
  /*!
   */
  bool is_done(void) const { return m_done; }

protected:
  static int s_argc;
  static char ** s_argv;
  static const char * s_prog_name;
  static std::set<Parse_command_line *> s_set;

  bool m_done;
};

#endif
