#include <iostream>
#if (defined _MSC_VER)
#include "my_getopt.h"
#else
#include <stdlib.h>
#include <getopt.h>
#endif
#include "Parse_main_cl.h"

char Parse_main_cl::s_option_str[] = "d:hi:v:";

/*!
 */
Parse_main_cl::Parse_main_cl(int argc, char * argv[]) :
  Parse_command_line(argc, argv), 
  m_verbose_level(0)
{
  m_dirs.add(".");
  doregister(this);
}

/*!
 */
void Parse_main_cl::print_help(void)
{
  std::cout << "Usage: " << s_prog_name << " [options]" << std::endl
            << "  -h\t\t\tprint this help message" << std::endl
            << "  -d <directory>\tadd <directory> to search list"
            << std::endl
            << "  -v <level>\t\tset verbose level" << std::endl;
}

/*!
 */
int Parse_main_cl::operator()(void)
{
  optind = 1;
  opterr = 0;

  int c;
  while ((c = getopt(s_argc, s_argv, s_option_str)) != EOF) {
    switch (c) {
     case 'd': m_dirs.add(optarg); break;
     case 'h': print_help(); m_done = true; break;
     case 'v': m_verbose_level = atoi(optarg); break;

     case 'i': break;
     default: return 0;
    }
  }
  return 0;
}
