#ifndef PARSE_WORK_SPACE_CL_H

#define PARSE_WORK_SPACE_CL_H



#include <iostream>

#include "Parse_command_line.h"

#include "Vector4f.h"



/*!

 */

class Parse_work_space_cl : public Parse_command_line {

private:

  void parse_input_options(char * options);

  

public:

  enum Input_id  {

    INPUT_FILE = 0, INPUT_F,

    NUM_VERTICES, NUM_V

  };

  

public:

  /*!

   */

  Parse_work_space_cl(void);

  

  /*!

   */

  virtual void print_help(void);



  /*!

   */

  virtual int operator()(void);



  /*!

   */

  virtual char * get_option_str(void) const { return s_option_str; }



  /*!

   */

  int get_verbose_level() const { return m_verbose_level; }



  /*!

   */

  const char * get_file_name(int i) const { return m_file_name[i]; }



  /*!

   */

  unsigned int get_num_vertices(int i) const { return m_num_vertices[i]; }

  

  /*!

   */

  const RGBA_color & get_shape_color(int i) const { return m_shape_color[i]; }

  

private:

#define NUM_POLYS 2



  static char * s_option_str;

  static char * s_input_opts[];



  static const char * s_default_file_base_name;

  static const char * s_default_file_ext_name;

  static const char * s_default_dir_name;



  int m_index;

  int m_verbose_level;

  char m_file_name[NUM_POLYS][128];

  RGBA_color m_shape_color[NUM_POLYS];

  unsigned int m_num_vertices[NUM_POLYS];

};



#endif

