#ifndef POLY_CIRCULAR_SEARCH
#define POLY_CIRCULAR_SEARCH

#include "Circular_search.h"
#include "Poly.h"

class Poly_circular_search : public Circular_search {
private:
  /*!
   */
  Poly * m_poly;

public:
  /*!
   */
  Poly_circular_search(Poly * poly) : m_poly(poly)
  {
    // Initialize range:
    m_range.set_num(get_num_normals());
  }

  /*!
   */
  virtual void get_normal(unsigned int id, Vector2f & normal) const
  {
    normal = m_poly->get_normal(id);
  }

  /*!
   */
  virtual void get_vertex(unsigned int id, Vector2f & vertex) const
  {
    vertex = m_poly->get_vertex(id);
  }
  
  /*!
   */
  virtual unsigned int get_num_normals() const
  {
    return m_poly->get_num_normals();
  }
};

#endif
