#ifndef RESHAPE_VIEWPORT_EVENT_H

#define RESHAPE_VIEWPORT_EVENT_H



#include <set>

#include<iostream>



#include "Event.h"

#include "Agent.h"



/*!

 */

template <class Tag>

class Reshape_viewport_event : public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;

  

  float m_win_scale;

  double m_left;

  double m_right;

  double m_bottom;

  double m_top;



protected:

  virtual void handle(Agent * agent) { agent->handle(this); }



public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  Reshape_viewport_event(void) : Event(), m_win_scale(1) {}

  virtual ~Reshape_viewport_event(void) {}

  

  virtual void identify(void)

  { std::cout << "Event: Reshape_viewport" << std::endl; }



  /*!

   */

  void set_win_scale(float win_scale) { m_win_scale = win_scale; }



  /*!

   */

  float get_win_scale(void) const { return m_win_scale; }



  /*!

   */

  void set_left(double left) { m_left = left; }



  /*!

   */

  double get_left(void) const { return m_left; }



  /*!

   */

  void set_right(double right) { m_right = right; }



  /*!

   */

  double get_right(void) const { return m_right; }



  /*!

   */

  void set_bottom(double bottom) { m_bottom = bottom; }



  /*!

   */

  double get_bottom(void) const { return m_bottom; }



  /*!

   */

  void set_top(double top) { m_top = top; }



  /*!

   */

  double get_top(void) const { return m_top; }

};



#endif

