#ifndef STATE_H

#define STATE_H



#include <math.h>

#include "Vector2f.h"



#include "Agent.h"



class State : public Agent {

public:

  virtual void on_entry(void) {}  

  virtual void on_exit(void) {}



  float calc_delta(Vector2f point0, Vector2f point1, float factor)

  {

    float xdiff = point1[0] - point0[0];

    float ydiff = point1[1] - point0[1];

    float dist = sqrtf(xdiff * xdiff + ydiff * ydiff);

    if (dist < 0.00001) return 1.0;

    float delta = factor / dist;

    return (delta > 0.0001f) ? delta : 0.001f;

  }



  inline float interp(float start, float end, float alpha)

  { return (1.0f - alpha) * start + alpha * end; }



  inline void interp(Vector2f & start, Vector2f & end, float alpha,

                     Vector2f & res)

  {

    res[0] = interp(start[0], end[0], alpha);

    res[1] = interp(start[1], end[1], alpha);

  }

};



#endif

