#if (defined _MSC_VER)
#include <windows.h>
#endif
#include <GL/gl.h>
#include <math.h>

#include "Trans_poly_circular_search.h"

#define PI (4*(float)atan(1))

/*!
 */
void Trans_poly_circular_search::draw(float radius)
{
  unsigned int num_normals = get_num_normals();
  unsigned int num = (get_end() > get_start()) ?
    get_end() - get_start() : get_end() - get_start() + num_normals;
  unsigned int num_vertices = m_num_vertices * num / num_normals;
    
  Vector2f start_normal;
  get_start_normal(start_normal);
  num_normals = get_num_normals();
  Vector2f end_normal;
  get_end_normal(end_normal);

  Vector2f start_point;
  start_point.scale(radius, start_normal);
  Vector2f end_point;
  end_point.scale(radius, end_normal);

  // Draw arc:
  glLineWidth(m_line_width);

  float delta = -PI * 2 / m_num_vertices;
  Matrix3f mat;
  mat.make_rot(0, 0, delta);
  glBegin(GL_LINE_STRIP);
  for (unsigned int i = 0; i < num_vertices; i++) {
    glVertex2fv((float *)&start_point);
    start_point.xform_pt(start_point, mat);
  }
  glVertex2fv((float *)&end_point);
  glEnd();
  
  //! Draw an arrow to indicate clockwise order.
  float angle = atan2f(m_arrow.get_arrow_length(), radius);
  mat.make_rot(0, 0, angle);
  end_point.xform_pt(end_point, mat);
  Vector2f dir;
  dir[0] = end_point[1];
  dir[1] = -end_point[0];
  dir.normalize();
  m_arrow.draw_arrow(end_point, dir);
}
