#ifndef COLLISION_TEST_EVENT_H

#define COLLISION_TEST_EVENT_H



#include <set>



#include "Event.h"



class Agent;



/*!

 */

class Collision_test_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;



protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  virtual ~Collision_test_event(void) {}



  /*!

   */

  virtual void identify(void);

};



#endif

