#ifndef EXTREME_VERTICES_EVENT_H

#define EXTREME_VERTICES_EVENT_H



#include <set>



#include "Event.h"



class Agent;



/*!

 */

class Extreme_vertices_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;



  unsigned int m_robot_extreme_vertex_id;

  unsigned int m_obstacle_extreme_vertex_id;

  

protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  virtual ~Extreme_vertices_event(void) {}



  /*!

   */

  virtual void identify(void);



  /*!

   */

  void set(unsigned int robot_id, unsigned int obstacle_id)

  {

    m_robot_extreme_vertex_id = robot_id;

    m_obstacle_extreme_vertex_id = obstacle_id;

  }



  /*!

   */

  void get(unsigned int & robot_id, unsigned int & obstacle_id) const

  {

    robot_id = m_robot_extreme_vertex_id;

    obstacle_id = m_obstacle_extreme_vertex_id;

  }

};



#endif

