#ifndef HIGHTLIGHT_EDGE_EVENT_H

#define HIGHTLIGHT_EDGE_EVENT_H



#include <set>



#include "Event.h"

#include "Vector2f.h"



class Agent;



/*!

 */

class Highlight_edge_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;



  Vector2f m_src;

  Vector2f m_dst;

  

protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  virtual ~Highlight_edge_event(void) {}



  /*!

   */

  virtual void identify(void);



  /*!

   */

  void set_vertices(const Vector2f & src, const Vector2f & dst)

  {

    m_src = src;

    m_dst = dst;

  }



  /*!

   */

  void get_vertices(Vector2f & src, Vector2f & dst) const

  {

    src = m_src;

    dst = m_dst;

  }

};



#endif

