#ifndef HIGHTLIGHT_NORMALS_EVENT_H

#define HIGHTLIGHT_NORMALS_EVENT_H



#include <set>



#include "Event.h"



class Agent;



/*!

 */

class Highlight_normals_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;



  int m_robot_normal_id;

  int m_obstacle_normal_id;

  

protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  virtual ~Highlight_normals_event(void) {}



  /*!

   */

  virtual void identify(void);



  /*!

   */

  void set(int robot_id, int obstacle_id)

  {

    m_robot_normal_id = robot_id;

    m_obstacle_normal_id = obstacle_id;

  }



  /*!

   */

  void get(int & robot_id, int & obstacle_id) const

  {

    robot_id = m_robot_normal_id;

    obstacle_id = m_obstacle_normal_id;

  }

};



#endif

