#ifndef MODE_EVENT_H

#define MODE_EVENT_H



#include <set>



#include "Event.h"

#include "Mode.h"



class Agent;



/*!

 */

class Mode_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;



  Mode m_mode;

  

protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  virtual ~Mode_event(void) {}



  /*!

   */

  virtual void identify(void);



  /*!

   */

  void set_mode(Mode mode) { m_mode = mode; }



  /*!

   */

  Mode get_mode(void) const { return m_mode; }

};



#endif

