#ifndef MOTION_EVENT_H

#define MOTION_EVENT_H



#include <time.h>

#include <set>



#include "Event.h"



class Agent;



/*!

 */

class Motion_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;

  

  /*! The x coordinate of the cursor location at the time of the event */

  int m_x;



  /*! The y coordinate of the cursor location at the time of the event */

  int m_y;



protected:

  virtual void handle(Agent * agent);



public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  Motion_event(void) : Event(), m_x(0), m_y(0) {}

  virtual ~Motion_event(void) {}



  virtual void identify(void);

  

  void set_x(int x) { m_x = x; }

  int get_x() const { return m_x; }

  void set_y(int y) { m_y = y; }

  int get_y() const { return m_y; }

};



#endif

