#ifndef MOUSE_WS_EVENT_H

#define MOUSE_WS_EVENT_H



#include <time.h>

#include <set>



#include "Event.h"



class Agent;



/*!

 */

class Mouse_ws_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;

  

  int m_button;

  int m_state;



  /*! The x coordinate of the cursor location at the time of the event */

  int m_x;



  /*! The y coordinate of the cursor location at the time of the event */

  int m_y;



protected:

  virtual void handle(Agent * agent);



public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  Mouse_ws_event(void) : Event(), m_button(0), m_state(0), m_x(0), m_y(0) {}

  virtual ~Mouse_ws_event(void) {}



  virtual void identify(void);



  void set_button(int button) { m_button = button; }

  int get_button() const { return m_button; }

  void set_state(int state) { m_state = state; }

  int get_state() const { return m_state; }

  void set_x(int x) { m_x = x; }

  int get_x() const { return m_x; }

  void set_y(int y) { m_y = y; }

  int get_y() const { return m_y; }

};



#endif

