#ifndef ROTATE_EVENT_H

#define ROTATE_EVENT_H



#include <set>



#include "Event.h"



class Agent;



/*!

 */

class Rotate_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;

  

  float m_angle;

  int m_poly_id;



protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  Rotate_event(void) : Event(), m_angle(0), m_poly_id(-1) {}

  virtual ~Rotate_event(void) {}

  

  virtual void identify(void);



  /*!

   */  

  void set_angle(float angle) { m_angle = angle; }



  /*!

   */  

  float get_angle(void) const { return m_angle; }

  

  /*!

   */

  void set_poly_id(int poly_id) { m_poly_id = poly_id; }



  /*!

   */

  int get_poly_id(void) const { return m_poly_id; }

};



#endif

