#ifndef SIMULATE_EVENT_H
#define SIMULATE_EVENT_H

#include <set>

#include "Event.h"

class Agent;

/*!
 */
class Simulate_event: public Event {
private:
  /*! A set of agents registered to process this type of event */
  static std::set<Agent *> s_set;

  bool m_simulate;
  
protected:
  virtual void handle(Agent * agent);
  
public:
  static void doregister(Agent * agent) { s_set.insert(agent); }
  static void unregister(Agent * agent) { s_set.erase(agent); }
  virtual const std::set<Agent *> & get_set(void) const { return s_set; }
  
  virtual ~Simulate_event(void) {}

  /*!
   */
  virtual void identify(void);

  /*!
   */
  void set_simulate(bool simulate) { m_simulate = simulate; }

  /*!
   */
  bool get_simulate(void) const { return m_simulate; }
};

#endif
