#ifndef TICK_EVENT_H

#define TICK_EVENT_H



#include <time.h>

#include <set>



#include "Event.h"



class Agent;



/*!

 */

class Tick_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;

  static unsigned int s_num_ticks;

  

  clock_t m_est_tick_duration;

  clock_t m_sim_time;



protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }



  Tick_event(void) : Event(), m_est_tick_duration(0), m_sim_time(0)

  { s_num_ticks++; }

  virtual ~Tick_event(void) {}

  

  virtual void identify(void);



  /*!

   */

  void set_est_tick_duration(clock_t est_tick_duration)

  { m_est_tick_duration = est_tick_duration; }



  /*!

   */

  clock_t get_est_tick_duration() const { return m_est_tick_duration; }



  /*!

   */

  void set_sim_time(clock_t sim_time) { m_sim_time = sim_time; }



  /*!

   */

  clock_t get_sim_time(void) const { return m_sim_time; }



  /*!

   */

  unsigned int get_num_ticks() const;

};



/*!

 */

inline unsigned int Tick_event::get_num_ticks() const { return s_num_ticks; }



#endif

