#ifndef TRANSLATE_EVENT_H

#define TRANSLATE_EVENT_H



#include <set>



#include "Event.h"

#include "Vector2f.h"



class Agent;



/*!

 */

class Translate_event: public Event {

private:

  /*! A set of agents registered to process this type of event */

  static std::set<Agent *> s_set;



  Vector2f m_vector;

  int m_poly_id;



protected:

  virtual void handle(Agent * agent);

  

public:

  static void doregister(Agent * agent) { s_set.insert(agent); }

  static void unregister(Agent * agent) { s_set.erase(agent); }

  virtual const std::set<Agent *> & get_set(void) const { return s_set; }

  

  Translate_event(void) : Event(), m_poly_id(-1)

  { m_vector[0] = m_vector[1] = 0; }

  virtual ~Translate_event(void) {}



  /*!

   */

  virtual void identify(void);



  /*!

   */

  void set_vector(const Vector2f & vec)

  { m_vector[0] = vec[0]; m_vector[1] = vec[1]; }

  void set_vector(float x, float y) { m_vector[0] = x; m_vector[1] = y; }



  /*!

   */

  const Vector2f & get_vector(void) const { return m_vector; }



  /*!

   */

  void set_poly_id(int poly_id) { m_poly_id = poly_id; }



  /*!

   */

  int get_poly_id(void) const { return m_poly_id; }

};



#endif

