#ifndef ISO_RECTANGLE_H

#define ISO_RECTANGLE_H



#include <iostream>

#include "Vector2f.h"



template <class Number_type_>

class Iso_rectangle {

public:

  typedef Number_type_ Number_type;

  

protected:

  Number_type m_vector[4];

  

public:

  /*!

   */

  Iso_rectangle()

  {

    m_vector[0] = m_vector[1] = m_vector[2] = m_vector[3] = 0;

  }



  /*!

   */

  Iso_rectangle(const Iso_rectangle & r)

  {

    m_vector[0] = r.m_vector[0];

    m_vector[1] = r.m_vector[1];

    m_vector[2] = r.m_vector[2];

    m_vector[3] = r.m_vector[3];

  }

  

  /*!

   */

  Iso_rectangle(const Vector2f & ll, const Vector2f & ur)

  {

    m_vector[0] = ll[0];

    m_vector[1] = ll[1];

    m_vector[2] = ur[0];

    m_vector[3] = ur[1];

  }



  /*!

   */

  Iso_rectangle(const Vector2f & left, const Vector2f & right,

                   const Vector2f & bottom, const Vector2f & top)

  {

    m_vector[0] = left[0];

    m_vector[1] = bottom[1];

    m_vector[2] = right[0];

    m_vector[3] = top[1];

  }



  /*!

   */

  Iso_rectangle(Number_type minx, Number_type miny,

                   Number_type maxx, Number_type maxy)

  { set(minx, miny, maxx, maxy); }



  /*!

   */

  void set(Number_type x, Number_type y)

  {

    m_vector[0] = m_vector[2] = x;

    m_vector[1] = m_vector[3] = y;

  }



  /*!

   */

  void set(const Vector2f & p) { set(p[0], p[1]); }



  /*!

   */

  void set(Number_type minx, Number_type miny,

           Number_type maxx, Number_type maxy)

  {

    m_vector[0] = minx;

    m_vector[1] = miny;

    m_vector[2] = maxx;

    m_vector[3] = maxy;

  }



  /*!

   */

  void get(Number_type & minx, Number_type & miny,

           Number_type & maxx, Number_type & maxy) const

  {

    minx = m_vector[0];

    miny = m_vector[1];

    maxx = m_vector[2];

    maxy = m_vector[3];

  }

  

  void set(const Vector2f & ll, const Vector2f & ur)

  {

    m_vector[0] = ll[0];

    m_vector[1] = ll[1];

    m_vector[2] = ur[0];

    m_vector[3] = ur[1];

  }

  

  void set_lower_left(Vector2f & ll)

  {

    m_vector[0] = ll[0];

    m_vector[1] = ll[2];

  }

  

  void set_upper_right(Vector2f & ur)

  {

    m_vector[2] = ur[0];

    m_vector[3] = ur[1];

  }

  

  /*!

   */

  void operator=(Iso_rectangle & r)

  {

    m_vector[0] = r.m_vector[0];

    m_vector[1] = r.m_vector[1];

    m_vector[2] = r.m_vector[2];

    m_vector[3] = r.m_vector[3];

  }

    

  /*!

   */

  void draw();

};



/*!

 */

template <class Number_type>

inline std::ostream & operator<<(std::ostream & os,

                                 const Iso_rectangle<Number_type> & r)

{

  Number_type minx, miny, maxx, maxy;

  r.get(minx, miny, maxx, maxy);

  os << minx << "," << miny << "," << maxx << "," << maxy;

  return os;

}



#if 0

std::istream & operator>>(std::istream & is, Iso_rectangle & r)

{

  return is;

}

#endif



#endif

