#include "Matrix4f.h"

#include "Vector4f.h"



/*!

 * Sets this vector to be v * m where v is treated as a row vector.

 */

void Vector4f::xform(const Vector4f & v, const Matrix4f & m)

{

  Vector4f t;

  t.set(v);

  m_vector[0] = t[0]*m[0][0] + t[1]*m[1][0] + t[2]*m[2][0] + t[3]*m[3][0];

  m_vector[1] = t[0]*m[0][1] + t[1]*m[1][1] + t[2]*m[2][1] + t[3]*m[3][1];

  m_vector[2] = t[0]*m[0][2] + t[1]*m[1][2] + t[2]*m[2][2] + t[3]*m[3][2];

  m_vector[3] = t[0]*m[0][3] + t[1]*m[1][3] + t[2]*m[2][3] + t[3]*m[3][3];

}

