#ifndef VIEWPORT_H
#define VIEWPORT_H

#include <iostream>

class Viewport {
private:
#define DEF_LEFT        0
#define DEF_BOTTOM      0
#define DEF_WIDTH       256
#define DEF_HEIGHT      256

  int m_left;
  int m_bottom;
  int m_width;
  int m_height;
  
public:

  /*!
   */
  Viewport(void);
  
  /*!
   */
  void set(int left, int bottom, int width, int height);

  /*!
   */
  void set_position(int left, int bottom);

  /*!
   */
  void set_dimension(int width, int height);
  
  /*!
   */
  void operator()(void) const;

  /*!
   */
  int get_left(void) const { return m_left; }

  /*!
   */
  int get_bottom(void) const { return m_bottom; }

  /*!
   */
  int get_width(void) const { return m_width; }

  /*!
   */
  int get_height(void) const { return m_height; }
};

/*!
 */
inline std::ostream & operator<<(std::ostream & os, const Viewport & vp)
{
  os << vp.get_left() << "," << vp.get_bottom() << ","
     << vp.get_width() << "," << vp.get_height();
  return os;
}  

#endif
