#include "Sim.h"
#include "Normal_diagram_scene.h"
#include "Parse_command_line.h"
#include "Parse_main_cl.h"

/*! main entry
 */
int main(int argc, char * argv[])
{
  Parse_main_cl parse_main_cl(argc, argv);
  int rc = parse_main_cl();
  if (rc < 0) return rc;
  
  int verbose_level = parse_main_cl.get_verbose_level();
  Sim::set_verbose_level(verbose_level);
  Event_handler::set_verbose_level(verbose_level);
  Normal_diagram_scene::set_verbose_level(verbose_level);

  // Construct all scenes:
  Normal_diagram_scene scene;

  if (!parse_main_cl.is_valid()) return -1;
  if (parse_main_cl.is_done()) return 0;

  // Construct simulator
  Sim sim(&scene, "Normal Diagram");
  sim.init(&argc, argv);
  sim();
  return 0;
}
